## serious-engine 0~git20250217+dfsg

=== debian/changelog ===
serious-engine (0~git20250217+dfsg-2) unstable; urgency=medium

  * Really fix build on mips64el and s390x

 -- Sébastien Noel <sebastien@twolife.be>  Sun, 23 Feb 2025 13:12:59 +0100

serious-engine (0~git20250217+dfsg-1) unstable; urgency=medium

  * New GIT snapshot.
  * Attempt to fix build on armel, mips64el, ppc64el, riscv64 and s390x
  * Drop the "-march=native" CFLAGS
  * d/control:
    - depends on neon-support on armhf
    - depends on sse2-support on i386 (the assembly code needs MMX support,
      but there isn't a mmx-support package, so use the next best thing)

 -- Sébastien Noel <sebastien@twolife.be>  Tue, 18 Feb 2025 12:36:02 +0100

serious-engine (0~git20230724+dfsg-1) unstable; urgency=low

  * Initial release. Closes: #1034630

 -- Sébastien Noel <sebastien@twolife.be>  Thu, 13 Feb 2025 10:08:37 +0100
