=== debian/control ===
Source: serious-engine
Section: contrib/games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Sébastien Noel <sebastien@twolife.be>
Rules-Requires-Root: no
Build-Depends:
  debhelper-compat(= 13),
  cmake,
  bison,
  flex,
  libsdl2-dev,
  libogg-dev,
  libvorbis-dev,
  zlib1g-dev
Standards-Version: 4.7.0
Homepage: https://github.com/ptitSeb/Serious-Engine
Vcs-Browser: https://salsa.debian.org/games-team/serious-engine
Vcs-Git: https://salsa.debian.org/games-team/serious-engine.git

Package: serious-sam-tfe
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, neon-support [armhf], sse2-support [i386], game-data-packager-runtime (>= 74)
Recommends: serious-sam-tfe-data | game-data-packager
Description: Serious Sam - The First Encounter
 a first-person shooter video game developed by Croteam and originally
 published in March 2001.
 .
 The series follows the adventures of protagonist Sam "Serious" Stone
 and his fight against the forces of the notorious extraterrestrial
 overlord Mental, who seeks to destroy humanity.
 .
 This package alone isn't of any use; it only contains the game engine,
 you will need a copy of the original game for this package to be useful.

Package: serious-sam-tse
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, neon-support [armhf], sse2-support [i386], game-data-packager-runtime (>= 74)
Recommends: serious-sam-tse-data | game-data-packager
Description: Serious Sam - The Second Encounter
 a first-person shooter video game developed by Croteam and originally
 published in February 2002.
 .
 The series follows the adventures of protagonist Sam "Serious" Stone
 and his fight against the forces of the notorious extraterrestrial
 overlord Mental, who seeks to destroy humanity.
 .
 This package alone isn't of any use; it only contains the game engine,
 you will need a copy of the original game for this package to be useful.
