## serious-engine 0~git20250224+dfsg

=== Sources/CMakeLists.txt ===
--- 
+++ 
@@ -59,6 +59,8 @@
     else()
         message(FATAL_ERROR "Error! USE_SYSTEM_ZLIB is set but neccessary developer files are missing")
     endif()
+else()
+    include_directories(${CMAKE_SOURCE_DIR}/Engine/zlib)
 endif()
 
 # RAKE! Where to install the binaries.
@@ -280,6 +282,3 @@
 
 option(USE_TREMOR "Use Tremor instead of Vorbis" FALSE)
 if (USE_TREMOR)
-    add_definitions(-DUSE_TREMOR=1)
-endif()
-
