=== debian/changelog ===
serious-engine (0~git20250224+dfsg-1) unstable; urgency=medium

  * New GIT snapshot.
  * Drop patches merged upstream
  * d/control: drop depends on sse2-support on i386.
    i386 is no longer supported as a regular architecture, i386 binaries are
    now only intended to be used on a 64-bit (amd64) CPU.

 -- Sébastien Noel <sebastien@twolife.be>  Mon, 11 Aug 2025 13:38:41 +0200
