=== debian/control ===
--- 
+++ 
@@ -13,16 +13,16 @@
   libogg-dev,
   libvorbis-dev,
   zlib1g-dev
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Homepage: https://github.com/ptitSeb/Serious-Engine
 Vcs-Browser: https://salsa.debian.org/games-team/serious-engine
 Vcs-Git: https://salsa.debian.org/games-team/serious-engine.git
 
 Package: serious-sam-tfe
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, neon-support [armhf], sse2-support [i386], game-data-packager-runtime (>= 74)
+Depends: ${shlibs:Depends}, ${misc:Depends}, neon-support [armhf], game-data-packager-runtime (>= 74)
 Recommends: serious-sam-tfe-data | game-data-packager
-Description: Serious Sam - The First Encounter
+Description: Serious Sam: The First Encounter
  a first-person shooter video game developed by Croteam and originally
  published in March 2001.
  .
@@ -35,9 +35,9 @@
 
 Package: serious-sam-tse
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, neon-support [armhf], sse2-support [i386], game-data-packager-runtime (>= 74)
+Depends: ${shlibs:Depends}, ${misc:Depends}, neon-support [armhf], game-data-packager-runtime (>= 74)
 Recommends: serious-sam-tse-data | game-data-packager
-Description: Serious Sam - The Second Encounter
+Description: Serious Sam: The Second Encounter
  a first-person shooter video game developed by Croteam and originally
  published in February 2002.
  .
