=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

extra_cmake_flags :=
ifneq (,$(filter $(DEB_HOST_ARCH), armhf))
    extra_cmake_flags += -DHAS_NEON=TRUE
endif


%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure --builddir=build_tfe --sourcedir=Sources -- -DCMAKE_BUILD_TYPE=RelWithDebInfo -DTFE=TRUE $(extra_cmake_flags)
	dh_auto_configure --builddir=build_tse --sourcedir=Sources -- -DCMAKE_BUILD_TYPE=RelWithDebInfo $(extra_cmake_flags)

override_dh_auto_build:
	dh_auto_build --builddir=build_tfe -- ecc
	dh_auto_build --builddir=build_tfe
	dh_auto_build --builddir=build_tse -- ecc
	dh_auto_build --builddir=build_tse

override_dh_auto_install:

override_dh_auto_test:

override_dh_auto_clean:
	dh_auto_clean --builddir=build_tfe
	dh_auto_clean --builddir=build_tse
