=== debian/watch ===
version=4 
opts="mode=git,pgpmode=none,repack,pretty=0~git%cd,repacksuffix=+dfsg,dversionmangle=s/\+dfsg$//,compression=xz" \
https://github.com/ptitSeb/Serious-Engine.git HEAD
