## serious-engine 0~git20250928+dfsg

=== debian/changelog ===
serious-engine (0~git20250928+dfsg-1) unstable; urgency=medium

  * New GIT snapshot.
    - fixes for big endian systems

 -- Sébastien Noel <sebastien@twolife.be>  Sat, 01 Nov 2025 15:18:02 +0100
