=== debian/control ===
--- 
+++ 
@@ -3,7 +3,6 @@
 Priority: optional
 Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
 Uploaders: Sébastien Noel <sebastien@twolife.be>
-Rules-Requires-Root: no
 Build-Depends:
   debhelper-compat(= 13),
   cmake,
