=== debian/watch ===
Version: 5
Mode: git
Pgpmode: none
Source: https://github.com/ptitSeb/Serious-Engine.git
Matching-Pattern: HEAD
Dversion-Mangle: auto
Git-Pretty: 0~git%cd
Repack: yes
Repacksuffix: +dfsg
Compression: xz
